#version 120
#include "/lib/fastMath.glsl"

#define AA 2 //[0 1 2]

#define WaterWaves

varying vec4 texcoord;
varying vec4 lmcoord;
varying vec4 color;

varying vec3 normal;

varying vec3 wpos;
varying vec3 viewVector;
varying mat3 tbnMatrix;

varying float mat;
varying float dist;

uniform vec3 cameraPosition;

uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferModelView;

uniform float frameTimeCounter;

attribute vec4 mc_Entity;
attribute vec4 at_tangent;

#if AA == 2
#include "/lib/jitter.glsl"
#endif

#define WaveSpeed 1.00 //[0.01 0.02 0.03 0.04 0.05 0.06 0.07 0.08 0.09 0.10 0.20 0.30 0.40 0.50 0.60 0.70 0.80 0.90 1.00 1.25 1.50 1.75 2.00 2.25 2.50 2.75 3.00 3.25 3.50 3.75 4.00 4.25 4.50 4.75 5.00 5.50 6.00 6.50 7.00 7.50 8.00 8.50 9.00 9.50 10.00] Speed of the water animation

void main(){
	mat = 1.0;
	
	texcoord = gl_MultiTexCoord0;
	lmcoord = gl_TextureMatrix[1] * gl_MultiTexCoord1;

	vec3 viewpos = transMAD(gl_ModelViewMatrix, gl_Vertex.rgb);
		 viewpos = transMAD(gbufferModelViewInverse, viewpos);

	vec3 worldpos = viewpos.xyz + cameraPosition;
	wpos = worldpos;

	#ifdef WaterWaves
	//Checks if the bottom of a block is touching the block beneath the block it's checking. (Good explaination huh)
	float fy = fract(worldpos.y + 0.001);
	if (fy > 0.02) {

		//Vertex Displacement
		viewpos.y += (cos((worldpos.x + worldpos.z) + frameTimeCounter * WaveSpeed * 3.0) * 0.5 + 0.5) * (sin(frameTimeCounter) * 0.5 + 0.5) * 0.05;
		viewpos.y += (sin((worldpos.x - worldpos.z) + frameTimeCounter * WaveSpeed * 4.0) * 0.5 + 0.5) * 0.05;
	}
	#endif

	viewpos = transMAD(gbufferModelView, viewpos);
	gl_Position = projMAD4(gl_ProjectionMatrix, viewpos);

	#if AA == 2
	gl_Position.xy = taaJitter(gl_Position.xy,gl_Position.w);
	#endif

	color = gl_Color;
	
	normal = normalize(gl_NormalMatrix * gl_Normal);
	vec3 tangent = normalize(gl_NormalMatrix * at_tangent.xyz);
    vec3 binormal = normalize(cross(tangent, normal));

    tbnMatrix = transpose(mat3(tangent, binormal, normal));
	
	viewVector = ( gl_ModelViewMatrix * gl_Vertex).xyz;
	viewVector = (tbnMatrix * viewVector);

	dist = length(gl_ModelViewMatrix * gl_Vertex);
	
	if (mc_Entity.x == 13000) mat = 0.2;
	if (mc_Entity.x == 13010);
	if (mat != 0.2) mat = 0.3;
}